(define-module (glicid packages benchmark)
  #:use-module (guix packages)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module (guix build-system gnu)
  #:use-module (guix build-system cmake)
;  #:use-module (guix licenses)
  #:use-module (gnu packages gawk)
  #:use-module (gnu packages gcc)
  #:use-module (gnu packages commencement)
  #:use-module (guix build-system python)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module ((guix utils) #:select (target-64bit?))
  #:use-module (gnu packages)
  #:use-module (gnu packages admin)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages base)
  #:use-module (gnu packages freeipmi)
  #:use-module (gnu packages linux)
  #:use-module (gnu packages mpi)
  #:use-module (gnu packages perl)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages parallel)
  #:use-module (gnu packages storage)
  #:use-module (gnu packages networking)
  #:use-module (gnu packages gtk)  
  #:use-module (gnu packages python)
  #:use-module (gnu packages python-science)
  #:use-module (gnu packages python-web)
  #:use-module (gnu packages python-xyz)
  #:use-module (gnu packages readline)
  #:use-module (gnu packages tcl)
  #:use-module (gnu packages tls)
  #:use-module (gnu packages commencement)
  #:use-module (gnu packages gcc)
  #:use-module (gnu packages chemistry)
  #:use-module (gnu packages sphinx)
  #:use-module (srfi srfi-1)
  #:use-module (gnu packages mpi)
  #:use-module (gnu packages sssd)
  #:use-module (gnu packages fabric-management)
  #:use-module ((gnu packages benchmark) #:prefix gnu:)
  #:use-module (gnu packages messaging)
  #:use-module (gnu packages web)
  #:use-module (gnu packages gnome)
  #:use-module (gnu packages cluster)  
  #:use-module (gnu packages libevent)
  #:use-module (gnu packages xorg)
  #:use-module (gnu packages fontutils)
  #:use-module (gnu packages flex)
  #:use-module (gnu packages bison)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages fontutils)
  #:use-module (guix build-system gnu)
  #:use-module (gnu packages image)
  #:use-module (gnu packages maths)
  #:use-module (guix utils)
  #:use-module (gnu packages cmake)
  #:use-module  (gnu packages pretty-print)
  #:use-module (gnu packages boost)
  #:use-module (gnu packages curl)
  #:use-module (gnu packages cryptsetup)
  #:use-module (gnu packages xml)
  #:use-module (gnu packages admin)
  #:use-module (gnu packages assembly)
  #:use-module (gnu packages authentication)
  #:use-module (gnu packages bdw-gc)
  #:use-module (gnu packages boost)
  #:use-module (gnu packages compression)
  #:use-module (gnu packages crypto)
  #:use-module (gnu packages cryptsetup)
  #:use-module (gnu packages curl)
  #:use-module (gnu packages databases)
  #:use-module (gnu packages disk)
  #:use-module (gnu packages gperf)
  #:use-module (gnu packages jemalloc)
  #:use-module (gnu packages linux)
  #:use-module (gnu packages lua)
  #:use-module (gnu packages ncurses)
  #:use-module (gnu packages networking)
  #:use-module (gnu packages nss)
  #:use-module (gnu packages openldap)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages python)
  #:use-module (gnu packages python-xyz)
  #:use-module (gnu packages sphinx)
  #:use-module (gnu packages tls)
  #:use-module (gnu packages web)
;;  #:use-module (gnu packages glicid)
  #:use-module (gnu packages pretty-print)
  #:use-module (gnu packages virtualization)
  #:use-module (glicid packages storage)
  #:use-module (glicid packages mpi)
  #:use-module (glicid packages gcc)
      #:use-module ((guix licenses) #:prefix license:)
      #:use-module (guix packages)
      #:use-module (guix download)
      #:use-module (guix utils)
      #:use-module (guix build utils)
      #:use-module (guix build-system cmake)
      #:use-module (guix build-system gnu)
      #:use-module (gnu packages)
      #:use-module (gnu packages algebra)
      #:use-module (gnu packages image-processing)
      #:use-module (gnu packages image)
      #:use-module (gnu packages graphics)
      #:use-module (gnu packages maths)
      #:use-module (gnu packages mpi)
      #:use-module (gnu packages python)
      #:use-module (gnu packages python-xyz)
      #:use-module (gnu packages compression)
      #:use-module (gnu packages commencement)
      #:use-module (gnu packages gcc)
      #:use-module (gnu packages pkg-config)
      #:use-module (gnu packages video)
      #:use-module (gnu packages llvm)
      #:use-module (gnu packages multiprecision)
      #:use-module (glicid utils)
      #:use-module (guix git-download)

)


;;;;;;;;


(define-public intel-mpi-benchmarks/openmpi-2021.3
 (package
  (inherit gnu:intel-mpi-benchmarks/openmpi)
  (name "intel-mpi-benchmarks")
  (version "2021.3")
  (source (origin
              (method git-fetch)
              (uri (git-reference
                    (url "https://github.com/intel/mpi-benchmarks")
                    (commit (string-append "IMB-v" version))))
              (file-name (git-file-name name version))
              (sha256
               (base32
                "04kczch2hlfzbgk929vcxx480kc6raba8rbz246j7d26k1z1zh8h"))
              (modules '((guix build utils)))
              (snippet
               '(begin
                  ;; Some source configuration files in the original tarball
                  ;; have inappropriate execute permissions, which interferes
                  ;; with the install phase below.
                  (for-each (lambda (file) (chmod file #o444))
                            (find-files "WINDOWS" "."))
                  #t))))

 )
)

(define intel-mpi-benchmark-transform-gcc-10
 (gcc10-instead-of-gcc intel-mpi-benchmarks/openmpi-2021.3))

(define intel-mpi-benchmark-transform-gcc-11
 (gcc11-instead-of-gcc intel-mpi-benchmarks/openmpi-2021.3))

(define-public intel-mpi-benchmarks/openmpi-2021.3-gcc-10
 (package
  (inherit intel-mpi-benchmark-transform-gcc-10)
  (version (string-append (package-version intel-mpi-benchmark-transform-gcc-10) "-gcc-10" ))
 )
)

(define-public intel-mpi-benchmarks/openmpi-2021.3-gcc-11
 (package 
  (inherit intel-mpi-benchmark-transform-gcc-11)
  (version (string-append (package-version intel-mpi-benchmark-transform-gcc-11) "-gcc-11" ))
 )
)

(use-modules (guix packages))
(use-modules (guix download))
(use-modules (guix build-system gnu))
(use-modules (gnu packages compression))
(use-modules (guix git-download))
(use-modules (gnu packages commencement))
(use-modules (glicid packages gcc))

(define-public stream-benchmarks
 (package
   (name "stream-benchmarks")
   (version "5.10-jh")
   (source (origin
            (method git-fetch)
            (uri 
              (git-reference
               (url "https://github.com/jeffhammond/STREAM.git")
               (commit "HEAD")
              )
            )
            
           (sha256 (base32 "1b5ka2h6rhp2103app6p0vq29y7qixcli9w874hb33y05ggjin8m"))
           (file-name (string-append name "-" version "-checkout"))
           )
  )

    (build-system gnu-build-system)
    (arguments
     `(#:phases
       (modify-phases %standard-phases
        (delete 'configure) ; no configure 
        (delete 'check) ; no check
        (replace 'install
         (lambda* (#:key outputs #:allow-other-keys)
          ;; Le Makefile du paquet ne fournit pas de règle « install »
          ;; alors on le fait nous-mêmes.
           (let ((bin (string-append (assoc-ref outputs "out")
                                      "/bin")))
        (install-file "stream_c.exe" bin)
        (install-file "stream_f.exe" bin)

        #t)))
       )
      )
    )
    (inputs `(("gfortran-toolchain@11" ,gfortran-toolchain-11)))
 
    (synopsis "STREAM  benchmark")
  (description "STREAM benchmark")
  (home-page "https://")
  (license ""))
)

;;defined by gricad / PA Boutier

(define-public osu-benchmarks
 (package
    (name "osu-benchmarks")
    (version "5.8")
    (source (origin
              (method url-fetch)
              (uri (string-append "https://mvapich.cse.ohio-state.edu/download/mvapich/osu-micro-benchmarks-" version ".tgz"))
              (sha256
              (base32
                "19a4wg0msipibkxsi8i0c34d07512yfaj2k37dxg5541ysdw690f"))))
    (build-system gnu-build-system)
    (arguments
     `(#:phases
       (modify-phases %standard-phases
         (add-after 'unpack 'setenv
           (lambda _
             (setenv "CC" (which "mpicc"))
             (setenv "CXX" (which "mpic++"))
             #t)))))
    (propagated-inputs
      `(("openmpi" ,openmpi)))
  (synopsis "OSU micro benchmarks")
  (description "OSU micro benchmark for mpi")
  (home-page "https://mvapich.cse.ohio-state.edu/benchmarks/")
  (license license:gpl2+)))


;;; glicid/benchmark.scm ends here
