(define-module (glicid packages nfs)
  #:use-module (guix packages)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module (guix build-system gnu)
  #:use-module (guix build-system cmake)
;  #:use-module (guix licenses)
  #:use-module (gnu packages gawk)
  #:use-module (gnu packages gcc)
  #:use-module (gnu packages commencement)
  #:use-module (guix build-system python)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module ((guix utils) #:select (target-64bit?))
  #:use-module (gnu packages)
  #:use-module (gnu packages admin)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages base)
  #:use-module (gnu packages freeipmi)
  #:use-module (gnu packages linux)
  #:use-module (gnu packages mpi)
  #:use-module (gnu packages perl)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages parallel)
  #:use-module (gnu packages storage)
  #:use-module (gnu packages networking)
  #:use-module (gnu packages gtk)  
  #:use-module (gnu packages python)
  #:use-module (gnu packages python-science)
  #:use-module (gnu packages python-web)
  #:use-module (gnu packages python-xyz)
  #:use-module (gnu packages readline)
  #:use-module (gnu packages tcl)
  #:use-module (gnu packages tls)
  #:use-module (gnu packages commencement)
  #:use-module (gnu packages gcc)
  #:use-module (gnu packages chemistry)
  #:use-module (gnu packages sphinx)
  #:use-module (srfi srfi-1)
  #:use-module (gnu packages mpi)
  #:use-module (gnu packages sssd)
  #:use-module (gnu packages fabric-management)
  #:use-module (gnu packages benchmark)
  #:use-module (gnu packages messaging)
  #:use-module (gnu packages web)
  #:use-module (gnu packages gnome)
  #:use-module (gnu packages cluster)  
  #:use-module (gnu packages libevent)
  #:use-module (gnu packages xorg)
  #:use-module (gnu packages fontutils)
  #:use-module (gnu packages flex)
  #:use-module (gnu packages bison)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages fontutils)
  #:use-module (guix build-system gnu)
  #:use-module (gnu packages image)
  #:use-module (gnu packages maths)     
  #:use-module (guix utils)
  #:use-module (gnu packages cmake)
  #:use-module  (gnu packages pretty-print)
  #:use-module (gnu packages boost)
  #:use-module (gnu packages curl)
  #:use-module (gnu packages cryptsetup)
  #:use-module (gnu packages xml)
  #:use-module (gnu packages admin)
  #:use-module (gnu packages assembly)
  #:use-module (gnu packages authentication)
  #:use-module (gnu packages bdw-gc)
  #:use-module (gnu packages boost) 
  #:use-module (gnu packages compression)
  #:use-module (gnu packages crypto)
  #:use-module (gnu packages cryptsetup)
  #:use-module (gnu packages curl)
  #:use-module (gnu packages databases)
  #:use-module (gnu packages disk)
  #:use-module (gnu packages gperf)
  #:use-module (gnu packages jemalloc)
  #:use-module (gnu packages linux)   
  #:use-module (gnu packages lua)     
  #:use-module (gnu packages ncurses) 
  #:use-module (gnu packages networking)
  #:use-module (gnu packages nss)
  #:use-module (gnu packages openldap)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages python)
  #:use-module (gnu packages python-xyz)
  #:use-module (gnu packages sphinx)
  #:use-module (gnu packages tls)   
  #:use-module (gnu packages web)   
;;  #:use-module (gnu packages glicid)
  #:use-module (gnu packages pretty-print)
  #:use-module (gnu packages virtualization)
  #:use-module (glicid packages storage)
  #:use-module (glicid packages mpi)
  #:use-module (glicid packages gcc)
#:use-module (gnu packages image)
#:use-module (gnu packages perl)
#:use-module (gnu packages shells)
#:use-module (gnu packages python)
#:use-module (gnu packages kerberos)
#:use-module (gnu packages gsasl)
#:use-module (gnu packages jemalloc)
#:use-module (gnu packages storage)
#:use-module (gnu packages file-systems)
#:use-module (gnu packages datastructures)
#:use-module (gnu packages bison)
#:use-module (gnu packages flex)
#:use-module (gnu packages onc-rpc)
  
)


;; https://github.com/nfs-ganesha/nfs-ganesha/archive/refs/tags/V3.5.tar.gz

(define-public nfs-ganesha
  (package
    (name "nfs-ganesha")
    (version "3.5")
    (source (origin
;              (method url-fetch)
;               (uri (string-append
;                "https://github.com/nfs-ganesha/nfs-ganesha/archive/refs/tags/V" version ".tar.gz"))
;
;
;              (sha256 (base32 "0545c6snmx66vpa427ij21md81vi5xa2v77428i4pq6fk6mgm06r"))
;             )
;    )
  (method git-fetch)
  (uri 
   (git-reference
    (url "https://github.com/nfs-ganesha/nfs-ganesha.git")
    (commit (string-append "V" version))
    (recursive? #t)
   )
  )
  (sha256 (base32 "0rdg3mjqrr4a8mywxkfis25gkbn4fylw42hg1d9cvp4dwrjk3hl4"))
  (file-name (string-append name "-" version "-checkout"))
  
 )
)
    (build-system cmake-build-system)
     (arguments
      `(
;;	#:validate-runpath? #f ;; we should know why
        #:configure-flags
        (list ;; Defaults to "lib64" on 64-bit archs.
             (string-append 
                ;             "-DCMAKE_INSTALL_LIBDIR="
                ;            (assoc-ref %outputs "out") "/lib" 

			      "-DLIB_INSTALL_DIR="
                              (assoc-ref %outputs "out") "/lib"

		;	     "-DCMAKE_INSTALL_RPATH="
                ;            (assoc-ref %outputs "out")
                ;             "/lib:"
                ;            (assoc-ref %outputs "out")
                ;             "/lib64"
             )
        )

         #:phases
        (modify-phases %standard-phases
           (add-after 'unpack 'chdir (lambda _ (chdir "src") #t)


         ) 
        )
       )
      )

;    (native-search-paths
;     (list
;           (search-path-specification
;            (variable "LIBRARY_PATH")
;            (files '("lib" "lib64"))
;           )
;     )
;    )

    (inputs
      `(
        ("perl", perl)
        ("oksh",oksh)
        ("python-3",python-3)
        ("mit-krb5",mit-krb5)
        ("gss",gss)
        ("pkg-config",pkg-config)
        ("jemalloc",jemalloc)
        ("ceph:lib",ceph "lib") ;; will use latest gnu or glicid ceph
        ("libnfsidmap",libnfsidmap)
        ("libnfs",libnfs)
;        ("xfsprogs",xfsprogs)
        ("liburcu",liburcu)
        ("bison",bison)
        ("flex",flex)
        ("libnsl",libnsl)
        ("util-linux" ,util-linux "lib") ;; uuid.h

       )
    )

;; placeholders

(synopsis "nfs-ganesha")
    (description
     "NFS-Ganesha.
 bla.")
    (home-page "https://")
    (license license:gpl3+))
;)

; )
;)
)
;;; glicid/nfs.scm ends here
