(define-module (glicid packages virtualization)
  #:use-module (guix packages)
  #:use-module (guix utils)
  #:use-module (gnu packages virtualization)
  #:use-module (gnu packages storage) ;; «regular» ceph is defined here
  #:use-module (glicid packages storage) ;; a «more up to date» version MAY be here
)

;;;;;;;;

(define-public qemu-with-rbd

  (package
    (inherit qemu) 
    (name "qemu-with-rbd")
    (arguments

     (substitute-keyword-arguments
         `(#:tests? #f
           ,@(package-arguments qemu)))
    ) 

    (inputs `(("ceph:lib", ceph "lib" ) ;; will take the more up to date ceph
      ,@(package-inputs qemu)))

  )
)

(define-public qemu-minimal-with-rbd

  (package
    (inherit qemu-minimal) 
    (name "qemu-minimal-with-rbd")
    (arguments

     (substitute-keyword-arguments
         `(#:tests? #f
           ,@(package-arguments qemu-minimal)))
    ) 

    (inputs `(("ceph:lib", ceph "lib" ) ;; will take the more up to date ceph
      ,@(package-inputs qemu-minimal)))

  )
)




;;; glicid/virtualizationvirtualization.scm ends here
